# -*- coding: utf-8 -*-
# příklady na konečný automat
# Jan Kybic, 2016


# automat přijímající jména proměnných

#def is_letter(c):
#  return "a"<=c<="z" or "A"<=c<="Z"

def is_variable_name(s):
  """ je 's' platné jméno proměnné v Pythonu? """
  state="start"
  for c in s:
    if state=="start":
       if c=="_" or is_letter(c):
         state="ano"
       else:
         return False
    else: # stav "ano"
      if not (c=="_" or is_letter(c) or c.isdigit()):
        return False   
  return state=="ano"
          
def is_letter(c):
  return c.isupper() or c.islower()

print(is_variable_name("moje_promenna12"))
print(is_variable_name("moje{}_promenna"))
print(is_variable_name("12moje{}_promenna"))

